(ns org.domaindrivenarchitecture.activity-pub-poc.parser-test
  (:require [clojure.test :refer :all]
            [org.domaindrivenarchitecture.activity-pub-poc.parser :as sut]))


(def processed (slurp "src/test/resources/deleted_comments_minimal.ttl"))
(def expected-definitions ["@prefix : <http://www.w3.org/ns/activitystreams#>"
                           "@prefix as: <http://www.w3.org/ns/activitystreams#>"
                           "@prefix owl: <http://www.w3.org/2002/07/owl#>"
                           "@prefix rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>"
                           "@prefix xml: <http://www.w3.org/XML/1998/namespace>"
                           "@prefix xsd: <http://www.w3.org/2001/XMLSchema#>"
                           "@prefix rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
                           "@base <http://www.w3.org/ns/activitystreams>"
                           "<http://www.w3.org/ns/activitystreams#> a owl:Ontology ;  rdfs:comment \"Extended Activity Streams 2.0 Vocabulary\"@en ;  rdfs:label \"Activity Streams 2.0\"@en ;  owl:imports <http://www.w3.org/ns/prov#>"
                           "rdf:langString a rdfs:Datatype"
                           "xsd:duration a rdfs:Datatype"])

(deftest remove-comments-test
  (is
   (= processed
      (sut/delete-comments-and-newlines "src/test/resources/minimal.ttl"))))

((deftest find-definitions-test
   (testing "Finding definitons"
     (is (= expected-definitions
            (sut/find-definitions processed))))))

;ToDo
; spec für eine property: as:name
; test für (defn get-spec-from-ttl ttl-file element-name [spezified predicates]) -> (str spec)

; ToDo
; spec generator

; das gleiche für as:actor